//
//  Poisson.swift
//  Classe - Aquarium
//
//  Created by Alain on 2014-10-12.
//  Copyright (c) 2014 Production sur support. All rights reserved.
//
//  Created by Alain on 2014-10-11.
//  Copyright (c) 2014 Production sur support. All rights reserved.
//
//  ============================================================================================
//  À l'usage exclusif des étudiants et étudiantes de
//  Techniques d'Intégration Multimédia
//  du cégep de Saint-Jérôme.
//  --------------------------------------------------------------------------------------------
//  Il est interdit de reproduire, en tout ou en partie, à des fins commerciales,
//  le code source, les scènes, les éléments graphiques, les classes et
//  tout autre contenu du présent projet sans l’autorisation écrite de l'auteur.
//
//  Pour obtenir l’autorisation de reproduire ou d’utiliser, en tout ou en partie,
//  le présent projet, veuillez communiquer avec:
//
//  Alain Boudreault, aboudrea@cstj.qc.ca
//
//  ============================================================================================

import Foundation

class Poisson {

    // Propriétés
    var nomPoisson:String
    var nomImage:String
    var force:Int
    let seuilDangerDeMort = 10
    
    // Constructeur
    /**
      Construire un poisson à partir d'un nom et d'une force
    */
    init(nomPoisson:String, force:Int) {
       println("Je suis le constructeur de Poisson.")
       self.nomPoisson  = nomPoisson
       self.force       = force
       self.nomImage    = "n/a"
    } // init()


    // Constructeur de convenance
    /**
    Construire un poisson pas de nom et de force zéro!
    */
    convenience init(){
        self.init(nomPoisson:"Pas de nom", force:0)
    } // convenience init()
    
    // Méthodes

    /**
      Méthode pour épuiser artificiellement le poisson
    */
    func epuiserLePoisson(force:Int){
        
        self.force -= force
    
        if self.force < 10 {
            println("Le poisson \(nomPoisson) est très très faible")
        }
    } // epuiserLePoisson

    /**
    Méthode pour nourrir le poisson
    */
    func nourrirLePoisson(nourriture:Int){
        force += 2 * nourriture
    } // nourrirLePoisson

    /**
      Je retourne une jolie description du poisson
    */
    func quiSuisJe() ->String {
        return "\n------------------\nJe suis le poisson \(nomPoisson) et j'ai une force de \(force)\n"
    } // quiSuisJe()
    

    
} // class Poisson